/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: boot32.h,v 1.4 2004/06/23 07:34:44 gondow Exp $
*/
#ifndef UDOS_BOOT32_H
#define UDOS_BOOT32_H
/* ---------------------------------------------------------------------- */
typedef uint32_t jmp_buf [6]; /* for ksetjmp/klongjmp */

/* defined in boot32.S. Note: boot32.h is not to be included in boot32.S. */
extern uint32_t kernel_page_dir [1024];
extern uint32_t kernel_page_tbl_IM [1024];

void kbd_intr_handler_entry   (void);
void pit_intr_handler_entry   (void);
void fdc_intr_handler_entry   (void);
void page_fault_handler_entry (void);
void tss_fault_handler_entry  (void);
void gp_fault_handler_entry   (void);
void system_call_entry        (void);
void test_entry               (void);
int  ksetjmp                  (jmp_buf env);
void klongjmp                 (jmp_buf env, int val);
/* ---------------------------------------------------------------------- */
#endif /* UDOS_BOOT32_H */
