/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: cpu.h,v 1.5 2004/06/23 07:34:44 gondow Exp $
*/

#ifndef UDOS_CPU_H
#define UDOS_CPU_H
/* ---------------------------------------------------------------------- */
#include "misc.h"
#include "vga.h"

enum { MAX_GDT = 256,  MAX_IDT = 256 };

struct GDT {
    uint16_t  word[4];
};

struct IDT {
    uint16_t  word[4];
};

struct selector {
    uint16_t  limit; 
    uint32_t  base  __attribute__ ((packed)); /* to eliminate padding */
};

struct TSS {
    /* _dummy* are all padding for alignment */
    uint16_t	link, _dummy1;
    uint32_t	esp0;
    uint16_t    ss0,  _dummy2;
    uint32_t	esp1;
    uint16_t    ss1,  _dummy3;
    uint32_t	esp2;
    uint16_t    ss2,  _dummy4;
    uint32_t	cr3;
    uint32_t	eip;
    uint32_t	eflags;
    uint32_t	eax, ecx, edx, ebx;
    uint32_t	esp, ebp, esi, edi;
    uint16_t	es,   _dummy5;
    uint16_t    cs,   _dummy6;
    uint16_t    ss,   _dummy7;
    uint16_t    ds,   _dummy8;
    uint16_t    fs,   _dummy9;
    uint16_t    gs,   _dummy10;
    uint32_t	ldt;
    uint16_t    trace;
    uint16_t	iobase;	   /* <= 0xDFFF */
};
/* ---------------------------------------------------------------------- */
void setup_GDT_again (void);
void setup_IDT_again (void);

extern struct GDT gdt [MAX_GDT];
extern struct TSS kernel_tss;
/* ---------------------------------------------------------------------- */
#endif /* UDOS_CPU_H */
