/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: fat12.h,v 1.9 2004/06/23 07:34:44 gondow Exp $
*/
#ifndef UDOS_FAT12_H
#define UDOS_FAT12_H
/* ---------------------------------------------------------------------- */
#include "fs.h"
#define DIR_DOT    ".          "
#define DIR_DOTDOT "..         "
#define DIR_ROOT   "/"

enum {
    ROOT_DIR_CLUS_NUM = 0,

    ATTR_READ_ONLY = 0x01,
    ATTR_HIDDEN    = 0x02,
    ATTR_SYSTEM    = 0x04,
    ATTR_VOLUME_ID = 0x08,
    ATTR_DIRECTORY = 0x10,
    ATTR_ARCHIVE   = 0x20,
    ATTR_LONG_NAME = ATTR_READ_ONLY | ATTR_HIDDEN 
                     | ATTR_SYSTEM | ATTR_VOLUME_ID,
    ATTR_LONG_NAME_MASK = ATTR_LONG_NAME | ATTR_DIRECTORY | ATTR_ARCHIVE,
};
/* ---------------------------------------------------------------------- */
int  is_directory   (struct FAT_dirent *dirent);
void FAT12_init     (void);
void FAT12_sync     (void);
int  FAT12_open     (struct file *fp, const char *path, int flag);
int  FAT12_close    (struct file *fp);
int  FAT12_read     (struct file *fp, void *buf, int count);
int  FAT12_write    (struct file *fp, void *buf, int count);
int  FAT12_readdir  (struct file *fp, struct FAT_dirent *dirent,
		     int skip_invalid);
int  FAT12_writedir (struct file *fp, struct FAT_dirent *dirent,
		     int skip_used);
int  FAT12_seek     (struct file *fp, int offset, int whence);
int  FAT12_mkdir    (const char *path);
int  FAT12_rmdir    (const char *path);
int  FAT12_unlink   (const char *path);
int  FAT12_stat     (const char *path, struct FAT_dirent *dirent);
/* ---------------------------------------------------------------------- */
#endif /* UDOS_FAT12_H */
