/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: list.h,v 1.2 2004/06/23 07:34:44 gondow Exp $
*/

#ifndef UDOS_LIST_H
#define UDOS_LIST_H
/* ---------------------------------------------------------------------- */
struct CDLL {
    void *data;
    struct CDLL *next, *prev;
};
/* ---------------------------------------------------------------------- */
struct CDLL *CDLL_create        (void *data);
void         CDLL_wrap          (struct CDLL *cdll, void *data);
void         CDLL_insert_head   (struct CDLL *head, struct CDLL *cdll);
void         CDLL_insert_tail   (struct CDLL *head, struct CDLL *cdll);
void         CDLL_insert_sorted (struct CDLL *head, struct CDLL *cdll,
				 int (*compare)(void *, void*));
void         CDLL_remove        (struct CDLL *cdll);
int          CDLL_is_null       (struct CDLL *head);
int          CDLL_is_single     (struct CDLL *head);
/* ---------------------------------------------------------------------- */
#endif /* UDOS_LIST_H */
