/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: misc.h,v 1.8 2004/06/23 07:34:44 gondow Exp $
*/

#ifndef UDOS_MISC_H
#define UDOS_MISC_H
/* ---------------------------------------------------------------------- */
#define NULL ((void *)0)
/* ---------------------------------------------------------------------- */
/* ILP32 types */
typedef signed char        int8_t;
typedef signed short       int16_t;
typedef signed int         int32_t;
typedef signed long long   int64_t;

typedef unsigned char      uint8_t;
typedef unsigned short     uint16_t;
typedef unsigned int       uint32_t;
typedef unsigned long long uint64_t;

#define panic(mesg)        _panic (mesg, __FILE__, __LINE__)
#define assert(val)        ((val) ? (void) 0 : panic ("assert failure"))

#define klock()     	   asm volatile ("pushf; cli")
#define kunlock()          asm volatile ("popf")
/* Cygwin gcc-3.3.1's -mpush-args does not work well, so we need the below. */
#define klock2(eflags)     asm volatile ("pushf; popl %0; cli":"=r"(eflags))
#define kunlock2(eflags)   asm volatile ("pushl %0; popf"::"r"(eflags))
/* ---------------------------------------------------------------------- */
void printk  (const char *fmt, ...);
void fwrite  (const char *buf, int size);
void _panic  (char *mesg, char *file, int line);

void *memcpy (void *dest, const void *src, uint32_t size);
void *memset (void *addr, int ch,          uint32_t size);
int  strcmp  (const char *s1, const char *s2);
int  strncmp (const char *s1, const char *s2, unsigned int len);
int  strlen  (const char *s);
char *strchr (const char *s, int c);
char *strrchr (const char *s, int c);
char *strdup (const char *s);
char *strcpy (char *s1, const char *s2);
/* ---------------------------------------------------------------------- */
#endif /* UDOS_MISC_H */
