/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: paging.h,v 1.10 2004/06/23 07:34:44 gondow Exp $
*/

#ifndef UDOS_PAGING_H
#define UDOS_PAGING_H
/* ---------------------------------------------------------------------- */
enum {
    PAGE_SIZE          = 4 * 1024,               /*  4KB */
};
/* ---------------------------------------------------------------------- */
void  setup_paging   (void);
void  page_fault_handler (uint32_t error);
void  create_aspace  (uint32_t *page_dir, char *filename, uint32_t size);
void *page_alloc     (void);
void  page_free      (void *page);
void *im_page_alloc  (void);
void  im_page_free   (void *page);
void  setup_kmalloc  (void);
void *kmalloc        (uint32_t size);
void  kfree          (void *ptr);
void  kmem_map       (uint32_t vaddr);
void  free_pages     (int free_stacks);
uint32_t *copy_pages (void);
void  free_kernel_stack (uint32_t cr3);
void  dump_pages     (void);
void  dump_mem_usage (void);
/* ---------------------------------------------------------------------- */
#endif /* UDOS_PAGING_H */
