/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: crt.S,v 1.15 2004/06/23 07:52:51 gondow Exp $
*/
#include "../kernel/syscall.h"
#define DEFINE_SYSCALL(name1, name2) \
	.global name1;               \
 name1: movl name2,    %eax;         \
	movl  4(%esp), %ebx;         \
        movl  8(%esp), %ecx;         \
        movl 12(%esp), %edx;         \
	movl 16(%esp), %edi;         \
        movl 20(%esp), %esi;         \
        int  $0x80;                  \
        ret
	/* 0(%esp)==return address */

.text
    .globl _start
_start:	
    movl %esp, %ebp
    call _cmain
    pushl %eax
    call _exit

DEFINE_SYSCALL (_fork,               $SYSCALL_FORK)
DEFINE_SYSCALL (_exec,               $SYSCALL_EXEC)
DEFINE_SYSCALL (_exit,               $SYSCALL_EXIT)
DEFINE_SYSCALL (_wait,               $SYSCALL_WAIT)
DEFINE_SYSCALL (_msleep,             $SYSCALL_MSLEEP)
DEFINE_SYSCALL (_open,               $SYSCALL_OPEN)
DEFINE_SYSCALL (_close,              $SYSCALL_CLOSE)
DEFINE_SYSCALL (_read,               $SYSCALL_READ)
DEFINE_SYSCALL (_write,              $SYSCALL_WRITE)
DEFINE_SYSCALL (_seek,               $SYSCALL_SEEK)
DEFINE_SYSCALL (_readdir,            $SYSCALL_READDIR)
DEFINE_SYSCALL (_mkdir,              $SYSCALL_MKDIR)
DEFINE_SYSCALL (_rmdir,              $SYSCALL_RMDIR)
DEFINE_SYSCALL (_unlink,             $SYSCALL_UNLINK)
DEFINE_SYSCALL (_sync,               $SYSCALL_SYNC)
DEFINE_SYSCALL (_chdir,              $SYSCALL_CHDIR)
DEFINE_SYSCALL (_stat,               $SYSCALL_STAT)
DEFINE_SYSCALL (_kill,               $SYSCALL_KILL)
DEFINE_SYSCALL (_getpid,             $SYSCALL_GETPID)
DEFINE_SYSCALL (_getppid,            $SYSCALL_GETPPID)
DEFINE_SYSCALL (_tcgetpid,           $SYSCALL_TCGETPID)
DEFINE_SYSCALL (_tcsetpid,           $SYSCALL_TCSETPID)

/* for debug */
DEFINE_SYSCALL (_printk,             $SYSCALL_PRINTK)
DEFINE_SYSCALL (__panic,             $SYSCALL_PANIC)
DEFINE_SYSCALL (_yield,              $SYSCALL_YIELD)
DEFINE_SYSCALL (_dump_mem_usage,     $SYSCALL_DUMP_MEM_USAGE)
DEFINE_SYSCALL (_dump_process_table, $SYSCALL_DUMP_PROCESS_TABLE)
DEFINE_SYSCALL (_infinite_loop,      $SYSCALL_INFINITE_LOOP)
DEFINE_SYSCALL (_sync_wait,          $SYSCALL_SYNC_WAIT)
DEFINE_SYSCALL (_sync_notify,        $SYSCALL_SYNC_NOTIFY)
DEFINE_SYSCALL (_dump_stack,         $SYSCALL_DUMP_STACK)

    .global _signal
_signal:
    movl $SYSCALL_SIGNAL,        %eax
    movl 4(%esp),                %ebx
    movl 8(%esp),                %ecx
    movl $_signal_handler_caller, %edx
    int  $0x80
    ret

.text
/* Note: %eax, %ecx, %edx are caller-save regs, not callee-save. */
    .globl _setjmp
_setjmp:	    
    movl 4(%esp), %eax	    # &jmp_buf
    movl %ebx,    0(%eax)
    movl %esi,    4(%eax)
    movl %edi,    8(%eax)
    movl %esp,    12(%eax)
    movl %ebp,    16(%eax)
    movl 0(%esp), %edx
    movl %edx,    20(%eax)  # return address
    movl $0,      %eax      # return value
    ret

    .globl _longjmp
_longjmp:	    
    movl 4(%esp),  %edx	    # &jmp_buf
    movl 8(%esp),  %eax     # return value
    movl 0(%edx),  %ebx
    movl 4(%edx),  %esi
    movl 8(%edx),  %edi
    movl 12(%edx), %esp
    movl 16(%edx), %ebp
    movl 20(%edx), %ecx
    movl %ecx,     0(%esp)
    ret

    .global _signal_handler_caller
_signal_handler_caller:
    popl %eax	     	      # popup address of signal handler
    call *%eax                # call signal handler
    popl %eax                 # discard signal number
    popa
    iret    /* to pop up eflags */

/* end-of-file */	
