/*
    udos: micro disk OS.
    Copyright (c) 2003, 2004   Katsuhiko Gondow (gondow@cs.titech.ac.jp)
    $Id: libudos.h,v 1.8 2004/06/23 07:52:51 gondow Exp gondow $
*/
/* ---------------------------------------------------------------------- */
#define NULL ((void *)0)

/* ILP32 types */
typedef signed char        int8_t;
typedef signed short       int16_t;
typedef signed int         int32_t;
typedef signed long long   int64_t;

typedef unsigned char      uint8_t;
typedef unsigned short     uint16_t;
typedef unsigned int       uint32_t;
typedef unsigned long long uint64_t;

typedef uint32_t jmp_buf [6];
/* ---------------------------------------------------------------------- */
void init_console (void);
void fdgets   (int fd, char *s, int size);
void *memcpy  (void *dest, const void *src, uint32_t size);
void *memset  (void *dest, int ch, uint32_t size);
int  atoi     (const char *s);
int  strlen   (const char *s);
char *strchr  (const char *s, int c);
char *strrchr (const char *s, int c);
int  strcmp   (const char *s1, const char *s2);
int  strncmp  (const char *s1, const char *s2, unsigned int len);
char *strcpy  (char *s1, const char *s2);
int  printf   (const char *fmt, ...);
int  setjmp   (jmp_buf env);
void longjmp  (jmp_buf env, int val);
/* ---------------------------------------------------------------------- */
