#include "udos.h"
#include "libudos.h"

int
cmain (int argc, char *argv [])
{
    struct FAT_dirent dirent;
    int i, fd, is_long = 0;
    char *path = ".";

    if (argc >= 2 && !strcmp (argv [1], "-l"))
	is_long = 1;
    fd = open (path, O_RDONLY);
    if (fd == -1) {
	printf ("No such file or directory: %s\n", path);
	return 1;
    }
    i = 0;
    while (readdir (fd, &dirent) > 0) {
	i++;
	if (is_long) {
	    printf ("%s, %d, %x\n", dirent.name, dirent.size, dirent.attr);
	} else {
	    if (ATTR_DIRECTORY & dirent.attr)
		printf ("%s/   ", dirent.name);
	    else 
		printf ("%s    ", dirent.name);
	    if (i % 5 == 0)
		printf ("\n");
	}
    }
    if (i % 5 != 0 && !is_long)
	printf ("\n");
    close (fd);
    return 0;
}
